using System;
using System.Collections.Generic;
using System.Text;
using BEPUphysics;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;

namespace BEPUphysicsDemos
{
    public class KinematicCharacterControllerInput
    {
        /*/// <summary>
        /// Physics representation of the character.
        /// </summary>
        public KinematicCharacterController characterController;
        /// <summary>
        /// Current offset from the position of the character to the 'eyes.'
        /// </summary>
        public Vector3 cameraOffset = new Vector3(0, .7f, 0);
        /// <summary>
        /// Camera to use for input.
        /// </summary>
        public Camera camera;
        /// <summary>
        /// Owning space of the character.
        /// </summary>
        public Space space;

        /// <summary>
        /// Whether or not to use the character controller's input.
        /// </summary>
        public bool isActive = true;


        /// <summary>
        /// Constructs the character and internal physics character controller.
        /// </summary>
        /// <param name="owningSpace">Space to add the character to.</param>
        /// <param name="cameraToUse">Camera to attach to the character.</param>
        public KinematicCharacterControllerInput(Space owningSpace, Camera cameraToUse)
        {
            characterController = new KinematicCharacterController(new Cylinder(Vector3.Zero, 2, .5f), 10, 80, 50, 3, 10f, false, .7f, 5, (float)Math.PI / 6, (float)Math.PI / 2.3f, 0, 0, .05f);

            space = owningSpace;
            space.add(characterController);



            camera = cameraToUse;
            deactivate();
        }

        /// <summary>
        /// Gives the character control over the camera and movement input.
        /// </summary>
        public void activate()
        {
            if (!isActive)
            {
                space.add(characterController.detector);
                isActive = true;
                camera.useMovementControls = false;
                characterController.body.moveTo(camera.position);
                characterController.isAirborne = true;
                characterController.isUpdating = true;
            }

        }

        /// <summary>
        /// Returns input control to the camera.
        /// </summary>
        public void deactivate()
        {
            if (isActive)
            {
                isActive = false;
                camera.useMovementControls = true;
                characterController.isUpdating = false;
                space.remove(characterController.detector);
            }
        }



        //Prevents spam-jumping; if the player jumps immediately after jumping, 
        //it is possible that they could still be in contact with the ground and thus get a double (or more) boost.
        float timeSinceLastJump = 0;
        /// <summary>
        /// Handles the input and movement of the character.
        /// </summary>
        /// <param name="dt">Time since last frame in simulation seconds.</param>
        public void update(float dt, KeyboardState keyboardInput, GamePadState gamePadInput)
        {
            if (isActive)
            {

                //Note that the character controller's update method is not called here; this is because it is handled within its owning space.
                //This method's job is simply to tell the character to move around based on the camera and input.

                //Puts the camera at eye level.
                camera.position = characterController.position + cameraOffset;
                Vector2 totalMovement = Vector2.Zero;
                timeSinceLastJump += dt;
#if XBOX360
                Vector3 forward = camera.getForwardVector();
                forward.Y = 0;
                forward.Normalize();
                Vector3 right = camera.getRightVector();
                totalMovement += gamePadInput.ThumbSticks.Left.Y * new Vector2(forward.X, forward.Z);
                totalMovement += gamePadInput.ThumbSticks.Left.X * new Vector2(right.X, right.Z);
                characterController.movementDirection = totalMovement;
#else


                //Collect the movement impulses.

                Vector3 movementDir;

                if (keyboardInput.IsKeyDown(Keys.E))
                {
                    movementDir = camera.getForwardVector();
                    totalMovement += Vector2.Normalize(new Vector2(movementDir.X, movementDir.Z));
                }
                if (keyboardInput.IsKeyDown(Keys.D))
                {
                    movementDir = camera.getForwardVector();
                    totalMovement -= Vector2.Normalize(new Vector2(movementDir.X, movementDir.Z));
                }
                if (keyboardInput.IsKeyDown(Keys.S))
                {
                    movementDir = camera.getLeftVector();
                    totalMovement += Vector2.Normalize(new Vector2(movementDir.X, movementDir.Z));
                }
                if (keyboardInput.IsKeyDown(Keys.F))
                {
                    movementDir = camera.getRightVector();
                    totalMovement += Vector2.Normalize(new Vector2(movementDir.X, movementDir.Z));
                }
                if (totalMovement == Vector2.Zero)
                    characterController.movementDirection = Vector2.Zero;
                else
                    characterController.movementDirection = Vector2.Normalize(totalMovement);

                //Jumping
                if (keyboardInput.IsKeyDown(Keys.A) && timeSinceLastJump > .3f)
                {
                    characterController.jump();   
                }

        
#endif
            }
       
        }
         *   * */
    }
}
